#ifndef __subplasma_h
#define __subplasma_h

extern "C" {
  void near makeplasma (void *start, long int seed, long int p);
  #pragma aux makeplasma "_^" parm [esi][edx][eax];
}

#endif
.386
.MODEL flat, c
IDEAL

; Ŀ
;  Plasma-Generator for Flat Protected Mode                                 
;  Dec. 1995 SUBMiSSiVE                                                     
; 
;
; How to call it:
;
; EDX: Initial seed value (any 32-bit value will do.. Different values
;      give different plasmas
;
; ESI: Address of a 64k buffer (a pointer to a 256x256 bitmap)
;
; EAX: Roughness of the plasma.. You might have to experiment with it
;      If the plasma looks boring increase the value, if it goes berserk
;      lower it.
;
; You might define make_pols to true and the plasmas will get funny spikes!
;
; The Routine saves all registers!
;


; --------------------------------------------------------------------------
; 03-26-98 06:19pm [Sub] Touched and removed a tiny bug. This version
;			 is also some bits smaller (and I realized, that
;		         this code could be a LOT smaller.... )
; --------------------------------------------------------------------------


UDATASEG

randval	dd ?

CODESEG

make_pols equ true

public makeplasma

proc random
    push edx
    mov  eax, 015a4e35h
    imul eax, [randval]
    inc  eax
    mov  [randval], eax
    sar  eax, 16
    imul eax, ebx
    pop  edx
    ret
endp

proc storepixel
    mov   ax,  di
    shr   ax,  2
    and   ebx, 0ffffh
    test  ax,  0ff00h
    jz    isok
    xor   al,  al
    test  ax,  ax
ifndef make_pols
    jns   notneg
else
    js    notneg
endif
    dec   al
notneg:
    mov   [byte ptr esi+ebx], al
    ret
isok:
    mov   [esi+ebx], al
    ret
endp

proc initpixel
    mov  di,  2
    call random
    shr  eax, 16
    add  di,  ax
    mov  ebx, ecx
; Note: there is no RET because the next routine must always execute after
; this one. So don't wonder, it's no bug, it saves some bytes!
endp

proc addb
    and  ebx,    0ffffh
    mov  al,     [byte ptr esi+ebx]
    xor  ah,     ah
    add  di,     ax
    mov  ebx,    ecx
    ret
endp

passtbl: dd offset pass1
         dd offset pass2
         dd offset pass3

proc makeplasma
local pval:dword, m: dword, m2: dword, pass:dword
    pushad

    mov  [randval], edx

    and  eax,    0000ffffh
    mov  edx,    offset addb
    xor  ebx,    ebx
    mov  [pval], eax
    inc  ebx
    call random
    mov  [esi],  al

    mov  [m2],   0100h
    mov  [m],    8080h

@@finestep:
    xor  ecx,    ecx
    mov  [pass], ecx
@@passloop:
    xor  ecx,    ecx
@@yloop:
    xor  cl,     cl
@@xloop:
    mov  eax,    [pass]
    mov  ebx,    [pval]
    jmp  [dword ptr passtbl + eax*4]

pass1:
    lea  ebx,    [ebx+ebx*2]
    call initpixel
    mov  ebx,    ecx
    add  bh, 	 [byte ptr m2]
    call edx
    add  bl,     [byte ptr m2]
    call edx
    add  bh,     [byte ptr m2]
    add  bl,     [byte ptr m2]
    call edx
    add  ebx,    [m]
    jmp weiter

pass2:
    call initpixel
    mov  ebx,    ecx
    add  bh,     [byte ptr m]
    sub  bl,     [byte ptr m]
    call edx
    add  ebx,    [m]
    call edx
    add  bh,     [byte ptr m2]
    call edx
    add  bh,     [byte ptr m]
    jmp  weiter

pass3:
    call initpixel
    mov  ebx,    ecx
    sub  bh,     [byte ptr m]
    add  bl,     [byte ptr m]
    call edx
    add  bl,     [byte ptr m2]
    call edx
    add  ebx,    [m]
    call edx
    add  bl,     [byte ptr m]

weiter:
    call storepixel

    add cl,     [byte ptr m2]
    jnz short   @@xloop
    add ch,     [byte ptr m2]
    jnz short   @@yloop
    mov cl, 2
    inc [pass]
    cmp [pass], ecx
    jbe @@passloop

    shr [pval], 1
    shr [m2],   1
    shr [m],    1
    cmp [m2],   ecx
    jae @@finestep
    popad
    ret
endp

end


end

